<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs"
    version="2.0">

  <!-- add @outputclass="keep-with-next" for <p> ending in ":" or "," -->
  <!-- (this must require that @outputclass not contain "keep-with-next" to avoid an infinite template loop) -->
  <xsl:template match="*[contains(@class, ' topic/p ')][matches(., '[,|:]$')][not(tokenize(@outputclass, '\s+') = 'keep-with-next')]" priority="101">
    <xsl:call-template name="snps-add-keep-with-next"/>
  </xsl:template>

  <!-- this is a reusable template that adds @outputclass="keep-with-next" to a <p> element-->
  <xsl:template name="snps-add-keep-with-next">
    <!-- make a copy of the <p> element, but add @outputclass="keep-with-next" -->
    <xsl:variable name="p" as="node()">
      <topic class="- topic/topic ">  <!-- do this for PDF Chemistry index-entry processing that checks if we're in topic content -->
        <xsl:copy select=".">
          <xsl:sequence select="@* except @outputclass"/>
          <xsl:attribute name="outputclass" select="string-join(('keep-with-next', tokenize(@outputclass, '\s+')), ' ')"/>
          <xsl:sequence select="node()"/>
        </xsl:copy>
      </topic>
    </xsl:variable>

    <!-- process it in the usual way; its results are returned as our results -->
    <xsl:apply-templates select="$p/*"/>  <!-- select the <p>, not the parent dummy topic -->
  </xsl:template>

</xsl:stylesheet>
